package com.eactive.eai.transformer.function.crypto;

import java.util.Stack;

import org.apache.commons.lang3.StringUtils;
import org.nfunk.jep.ParseException;
import org.nfunk.jep.function.PostfixMathCommand;
import java.nio.charset.StandardCharsets;

// kj bank import 2025-09-23 jwhong
import com.kjbank.encrypt.exchange.crypto.AES256Cipher;

public class AES256KJDecrypt extends PostfixMathCommand {
    public AES256KJDecrypt() {
        numberOfParameters = 2;
    }

    public void run(Stack inStack) throws ParseException {
        checkStack(inStack);
        
        // USER FUNCTION에서 Parameter 에서 가져옴 
        Object param2 = inStack.pop();
        String param2Str = String.valueOf(param2); // null 안전 처리        
        String decryptKey = param2Str.substring(10,42);
        
        Object param = inStack.pop();

        byte[] value = null;

        if (param instanceof String) {
            value = ((String) param).getBytes();
        } else if (param instanceof byte[]) {
            value = (byte[]) param;
        } else if (param instanceof Double) {
        	if (((Double) param).doubleValue() == Math.round(((Double) param).doubleValue())) {
        		value = new Long(Math.round(((Double) param).doubleValue())).toString().getBytes();
        	} else {
                value =((Number) param).toString().getBytes();
        	}
        } else if (param instanceof Number) {
            value = ((Number) param).toString().getBytes();
        } else if (param == null) {
            inStack.push(null);
            return;
        } else {
            throw new ParseException("Function의 파라미터 인수가 byte[] 또는 String이 아닙니다. : " + param);
        }

        try {
			String decryptedData = AES256Cipher.decrypt(new String(value, StandardCharsets.UTF_8), decryptKey);   
			
        	inStack.push(decryptedData);
        } catch (Exception e) {
            //throw new ExecutionException(e.getMessage(), parameters, e);
            throw new ParseException(e.getMessage(), e);
        }    	
    }
}
